    001    /* ========================================================================
    002     * JCommon : a free general purpose class library for the Java(tm) platform
    003     * ========================================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jcommon/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------------------
    028     * DefaultConfiguration.java
    029     * -------------------------
    030     * (C)opyright 2003, 2004, by Thomas Morgner and Contributors.
    031     *
    032     * Original Author:  Thomas Morgner;
    033     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034     *
    035     * $Id: DefaultConfiguration.java,v 1.4 2005/10/18 13:24:19 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 04.06.2003 : Initial version (TM);
    040     *
    041     */
    042
    043    package org.jfree.util;
    044
    045    import java.util.Collections;
    046    import java.util.Enumeration;
    047    import java.util.Iterator;
    048    import java.util.Properties;
    049    import java.util.TreeSet;
    050
    051    /**
    052     * Default configuration.
    053     *
    054     * @author Thomas Morgner.
    055     *
    056     */
    057    public class DefaultConfiguration extends Properties implements Configuration {
    058
    059        /**
    060         * Creates an empty property list with no default values.
    061         */
    062        public DefaultConfiguration() {
    063            super();
    064        }
    065
    066        /**
    067         * Returns the configuration property with the specified key.
    068         *
    069         * @param key  the property key.
    070         *
    071         * @return the property value.
    072         */
    073        public String getConfigProperty(final String key) {
    074            return getProperty(key);
    075        }
    076
    077        /**
    078         * Returns the configuration property with the specified key (or the specified default value
    079         * if there is no such property).
    080         * <p>
    081         * If the property is not defined in this configuration, the code will lookup the property in
    082         * the parent configuration.
    083         *
    084         * @param key  the property key.
    085         * @param defaultValue  the default value.
    086         *
    087         * @return the property value.
    088         */
    089        public String getConfigProperty(final String key, final String defaultValue) {
    090            return getProperty(key, defaultValue);
    091        }
    092
    093        /**
    094         * Searches all property keys that start with a given prefix.
    095         *
    096         * @param prefix the prefix that all selected property keys should share
    097         * @return the properties as iterator.
    098         */
    099        public Iterator findPropertyKeys(final String prefix) {
    100            final TreeSet collector = new TreeSet();
    101            final Enumeration enum1 = keys();
    102            while (enum1.hasMoreElements()) {
    103                final String key = (String) enum1.nextElement();
    104                if (key.startsWith(prefix)) {
    105                    if (collector.contains(key) == false) {
    106                        collector.add(key);
    107                    }
    108                }
    109            }
    110            return Collections.unmodifiableSet(collector).iterator();
    111        }
    112
    113        public Enumeration getConfigProperties()
    114        {
    115          return keys();
    116        }
    117    }